'''''''''''''''''''''''''''''''''''''''''''
' Program    : Plays ANI Files            '
' Name       : OPENANI Version 0.1        '
' Programmer : Yousuf Philips             '
' Company    : Y P I                      '
' Updated On : 17th of April 1999         '
' Email      : philipz85@hotmail.com]     '
' Website    : http://www.philipz.com/qb/ '
'''''''''''''''''''''''''''''''''''''''''''

'/*               Do not edit this file if you distribute it.              */'
'/*  (c) Copyrighted by YPI in 1998 | All Rights Reserved | Public Domain  */'

'/* This program has been created by YPI (Basic Programming Incorporation) */'
'/* as a utility to play Windows (ANI) animated cursor files in QBASIC.    */'
'/*                                                                        */'
'/* It was designed to play 4 and 8-bit uncompressed ANI files. It is      */'
'/* possible to improve it to play any time of ANI file.                   */'

'/* An original program created by the professional programmers at YPI.    */'
'/* If you use any of this code in your program then you must credit YPI,  */'
'/* it would be appreciated if you sent us a copy of your program also.    */'
'/* Please send your comments and suggestions to <philipz85@hotmail.com>   */'

DECLARE SUB ShowANI (FileName$)

TYPE ANIMainHeader
   ValidID AS STRING * 4           '/* Must be 'RIFF'
   SizeOfFile AS LONG              '/* Size of the ANI File - 8
   RIFFType AS STRING * 4          '/* Must be 'ACON'
END TYPE

TYPE IconChunk
    ValidID AS STRING * 4           '/* Must be 'icon'
    SizeOfChunk AS LONG             '/* Size of the icon
    SomeJunk AS STRING * 11         '/* Somethings that I don't understand
END TYPE

TYPE BMPInfoHeader
   LengthOfHeader AS LONG         '/* Must be 40
   ImageWidth AS LONG             '/* Icon image width
   ImageHeight AS LONG            '/* Icon image height * 2
   Planes AS INTEGER              '/* Icon image planes - Must be 1
   BitsPerPixel AS INTEGER        '/* Icon image bits per pixel - Must 4 or 8
   CompressMethod AS LONG         '/* Icon image compression - Must be 0
   ImageSizeInBytes AS LONG       '/* Size of Icon image in bytes
   HorizontalRatio AS LONG        '/* Not Important
   VerticalRatio AS LONG          '/* Not Important
   ColorsUsed AS LONG             '/* Number of colors used
   ImportantColors AS LONG        '/* Number of important colors
END TYPE

IF COMMAND$ <> "" THEN
FileName$ = COMMAND$
CALL ShowANI(FileName$)
ELSE
 PRINT "OpenANI v0.1"
 PRINT "(C) Data Components Software Development"
 PRINT "Code by: Yousuf Philips of Y P I, Inc."
 PRINT
 PRINT "Usage: OPENANI[.exe] ANIFILE.ANI"
 SYSTEM
END IF

DEFINT A-Z
SUB ShowANI (FileName$)

CLS
DIM ANIMainHeader AS ANIMainHeader
DIM IconChunk AS IconChunk
DIM BMPInfoHead AS BMPInfoHeader
Byte$ = SPACE$(1)

Start:
OPEN FileName$ FOR BINARY AS #255
IF LOF(255) = 0 THEN
   PRINT " FILE IS EMPTY"
   CLOSE
   KILL FileName$
   EXIT SUB
END IF
 
GET #255, , ANIMainHeader
IF ANIMainHeader.RIFFType <> "ACON" THEN
   PRINT " INVALID WINDOWS 95 ANIMATED CURSOR"
END IF

DWord$ = SPACE$(4)
Position& = LOC(255) + 1
DO
   Position& = Position& + 1
   GET #255, Position&, DWord$
LOOP UNTIL DWord$ = "fram"

DO
  CurrentPosition& = LOC(255) + 9
  GET #255, , IconChunk
  IF IconChunk.ValidID <> "icon" THEN
     CLOSE
     GOTO Start
  END IF
  CurrentPosition& = CurrentPosition& + IconChunk.SizeOfChunk
  Position& = LOC(255) + 1
  DO
     Position& = Position& + 1
     GET #255, Position&, Byte$
  LOOP UNTIL Byte$ = CHR$(40)
  SEEK #255, Position&
  GET #255, , BMPInfoHead
  IF BMPInfoHead.Planes <> 1 THEN
     PRINT " PROGRAM CAN'T OPEN NONE 1 PLANE IMAGES"; BMPInfoHead.Planes
     EXIT SUB
  END IF
  IF BMPInfoHead.BitsPerPixel > 8 THEN
     PRINT " ONLY 4 and 8 BIT IMAGES CAN BE LOADED"; BMPInfoHead.BitsPerPixel
     EXIT SUB
  END IF
  IF BMPInfoHead.CompressMethod <> 0 THEN
     PRINT " ONLY UNCOMPRESSED ANIMATED CURSORS CAN BE LOADED"
     EXIT SUB
  END IF
  Palette$ = SPACE$((2 ^ BMPInfoHead.BitsPerPixel) * 4)
  GET #255, , Palette$
  SCREEN 13
  FOR ColorNumber = 0 TO 2 ^ BMPInfoHead.BitsPerPixel - 1
     OUT &H3C8, ColorNumber
     OUT &H3C9, INT(ASC(MID$(Palette$, (ColorNumber * 4) + 3, 1)) / 4)
     OUT &H3C9, INT(ASC(MID$(Palette$, (ColorNumber * 4) + 2, 1)) / 4)
     OUT &H3C9, INT(ASC(MID$(Palette$, (ColorNumber * 4) + 1, 1)) / 4)
  NEXT ColorNumber
  IF INKEY$ <> "" THEN CLOSE : EXIT SUB
  IF BMPInfoHead.BitsPerPixel = 8 THEN
     Bytes$ = SPACE$(BMPInfoHead.ImageWidth): Extra$ = SPACE$(4 - (BMPInfoHead.ImageWidth MOD 4))
     FOR YHeight = CINT(BMPInfoHead.ImageHeight / 2) + 3 TO 0 STEP -1
        GET #255, , Bytes$
        FOR XWidth = 0 TO BMPInfoHead.ImageWidth - 1
           PSET (XWidth, YHeight), ASC(MID$(Bytes$, XWidth + 1, 1))
        NEXT XWidth
        IF LEN(Extra$) <> 4 THEN
           GET #255, , Extra$
        END IF
     NEXT YHeight
  ELSE
     Bytes$ = SPACE$(CINT(BMPInfoHead.ImageWidth / 2))': Extra$ = SPACE$(4 - (CINT(BMPInfoHead.ImageWidth / 2) MOD 4))
     FOR YHeight = (BMPInfoHead.ImageHeight / 2) - 1 TO 0 STEP -1
        GET #255, , Bytes$
        FOR XWidth = 0 TO BMPInfoHead.ImageWidth - 1 STEP 2
           PSET (XWidth, YHeight), (ASC(MID$(Bytes$, (XWidth / 2) + 1, 1)) AND 240) / 16
           PSET (XWidth + 1, YHeight), ASC(MID$(Bytes$, (XWidth / 2) + 1, 1)) AND 15
        NEXT XWidth
     NEXT YHeight
   SEEK #255, CurrentPosition&
  END IF
LOOP
END SUB

