'''''''''''''''''''''''''''''''''''''''''''
' Program    : Loads PCX Files            '
' Name       : OPENPCX Version 0.4        '
' Programmer : Yousuf Philips             '
' Company    : Y P I                      '
' Updated On : 19th of December 1999      '
' Email      : philipz85@hotmail.com      '
' Website    : http://www.philipz.com/qb/ '
'''''''''''''''''''''''''''''''''''''''''''

'/*               Do not edit this file if you distribute it.              */'
'/*  (c) Copyrighted by YPI in 1998 | All Rights Reserved | Public Domain  */'

'/* This program has been created by YPI (Basic Programming Incorporation) */'
'/* as a utility to load PCX files in Qbasic.                              */'

'/* OPENPCX Version 0.4                                                    */'
'/*       * Loading increased by an average of 15% in Real MSDOS &         */'
'/*         an average of 30% in Windows MS-DOS prompt                     */'
'/*       * Removed remarks to keep the code nice and small                */'
'/*       * Error handling added for 24-bit PCX files                      */'

'/* OPENPCX Version 0.3                                                    */'
'/*       * First release of YPI PCX Loader                                */'
'/*       * Able to display correctly any 8-bit PCX files                  */'
'/*       * Remark lines throughout the program explaining the exact       */'
'/*         process used by the program to decode the PCX file             */'

'/* If you use any of this code in your program then you must credit YPI.  */'
'/* This program has been placed in Public Domain and All Rights Are       */'
'/* Reserved.                                                              */'

'/* YPI is a BASIC Programming Incorporation which was started in 1998,    */'
'/* with the aims of improving Qbasic by providing good quality programs   */'
'/* which would truly benefit Qbasic programmers. YPI has put out a large  */'
'/* collection of image loaders and savers (BMP, PCX, AVI, ANI, ICO, FLI,  */'
'/* TIF, XPM, LBM, XPM). But YPI has also archive utilities of ZIP & RAR   */'
'/* which can display the files compressed in the files. Other programs    */'
'/* like a virus scanner, paint brush, etc. have been created as well as 4 */'
'/* tutorials (not completed because nobody asked for them). All of these  */'
'/* are available at the YPI Qbasic Homepage <http://www.philipz.com/qb/>  */'

DECLARE SUB PCXInfo (FileName$)
DECLARE SUB ShowPCX (FileName$, XPoint%, YPoint%)

TYPE PCXHeader
   ValidID AS STRING * 1               ' Must be - 10
   PCXVersion AS STRING * 1            ' PCX Version
                                       ' 0 - Version 2.5
                                       ' 2 & 3 - Version 2.8
                                       ' 5 - Version 3
   Reserved1 AS STRING * 1             ' Reserved Area
   BitsPerPixel AS STRING * 1          ' Number of bits per pixel per plane
   MinimumX AS INTEGER                 ' ]
   MinimumY AS INTEGER                 ' ]] Co-ordinates of a window in which
   MaximumX AS INTEGER                 ' ]] the image should be displayed in
   MaximumY AS INTEGER                 ' ]
   ImageWidth AS INTEGER               ' The width of the image [Not always]
   ImageHeight AS INTEGER              ' The height of the image [Not always]
   PaletteFor4Bit AS STRING * 48       ' Palette area for 4-bit PCX files
   Reserved2 AS STRING * 1             ' Reserved Area
   Planes AS STRING * 1                ' Number of planes per pixel
   BytesPerLine AS INTEGER             ' Number of bytes per line [The actual
                                       '                               width]
   PaletteInterpret AS INTEGER         ' Can't remember
   NotImp AS LONG                      ' Not Important
   Reserved3 AS STRING * 54            ' Reserved Area
END TYPE

TYPE PaletteFor8Bit
   PaletteRGB AS STRING * 768
END TYPE

DEFINT A-Z
IF COMMAND$ <> "" THEN
FileName$ = COMMAND$
IF LEN(LTRIM$(FileName$)) = 0 THEN
   END
ELSEIF INSTR(FileName$, ".") = 0 THEN
   FileName$ = FileName$ + ".pcx"
END IF

CALL PCXInfo(FileName$)
Wait$ = INPUT$(1)
CALL ShowPCX(FileName$, XPoint, YPoint)
Wait$ = INPUT$(1)
ELSE
  PRINT "OpenPCX v0.4"
    PRINT "(C) Data Components Software Development"
      PRINT "Code by: Yousuf Philips of Y P I, Inc."
        PRINT
          PRINT "Usage: OPENPCX[.exe] PCXFILE.PCX"
            SYSTEM
END IF

SUB PCXInfo (FileName$)

OPEN FileName$ FOR BINARY AS #255
IF LOF(255) = 0 THEN
   PRINT " FILE IS EMPTY"
   CLOSE #255: KILL FileName$: EXIT SUB
END IF

CLS
DIM PCXHead AS PCXHeader
GET #255, , PCXHead

IF ASC(PCXHead.ValidID) <> 10 THEN
   PRINT " Invalid PCX File"
   EXIT SUB
ELSE
   PRINT " Valid PCX File"
END IF

IF ASC(PCXHead.PCXVersion) = 0 THEN
   PRINT " Version - 2.5 of PC PaintBrush"
ELSEIF ASC(PCXHead.PCXVersion) = 2 THEN
   PRINT " Version - 2.8 with palette"
ELSEIF ASC(PCXHead.PCXVersion) = 3 THEN
   PRINT " Version - 2.8 without palette"
ELSEIF ASC(PCXHead.PCXVersion) = 4 THEN
   PRINT " PC PaintBrush for Windows"
ELSEIF ASC(PCXHead.PCXVersion) = 5 THEN
   PRINT " Version - 3"
END IF

PRINT
PRINT " Screen Size - ["; PCXHead.MinimumX; ","; PCXHead.MinimumY; "]";
PRINT " - ["; PCXHead.MaximumX; ","; PCXHead.MaximumY; "]"
PRINT " Width -"; PCXHead.ImageWidth
PRINT " Height -"; PCXHead.ImageHeight
PRINT
PRINT " Number of Bits Per Pixel -"; ASC(PCXHead.BitsPerPixel)
PRINT " Number Of Planes -"; ASC(PCXHead.Planes)
PRINT
PRINT " Bytes Per Lines -"; PCXHead.BytesPerLine
PRINT " Palette Information - ";
IF PCXHead.PaletteInterpret = 0 OR PCXHead.PaletteInterpret = 1 THEN
   PRINT "Color or B&W Image"
ELSE
   PRINT "Gray Scale Image"
END IF
CLOSE

END SUB

SUB ShowPCX (FileName$, XPoint, YPoint)

DIM Palettez AS PaletteFor8Bit

OPEN FileName$ FOR BINARY AS #255
IF LOF(255) = 0 THEN
   PRINT " FILE IS EMPTY"
   CLOSE #255: KILL FileName$: EXIT SUB
END IF

CLS
DIM PCXHead AS PCXHeader
GET #255, , PCXHead

IF PCXHead.ValidID <> CHR$(10) THEN
   PRINT " Invalid PCX File"
   EXIT SUB
ELSEIF PCXHead.PCXVersion <> CHR$(5) THEN
   PRINT " THIS VERSION CAN ONLY OPEN VERSION 3 PCX Files"
   EXIT SUB
ELSEIF PCXHead.BitsPerPixel = CHR$(8) AND PCXHead.Planes = CHR$(3) THEN
   PRINT " 24-BIT PCX Files Can Not Be Loaded"
   EXIT SUB
ELSEIF PCXHead.BitsPerPixel <> CHR$(8) THEN
   PRINT " ONLY 8-BIT PCX's CAN BE LOADED"
   EXIT SUB
ELSEIF PCXHead.Planes <> CHR$(1) THEN
   PRINT " Only 1 Plane PCX Files Can Be Loaded"
   EXIT SUB
END IF

PCXHead.ImageWidth = PCXHead.MaximumX - PCXHead.MinimumX + 1
PCXHead.ImageHeight = PCXHead.MaximumY - PCXHead.MinimumY + 1

SCREEN 13
SEEK #255, LOF(255) - 767
GET #255, , Palettez
OUT &H3C8, 0
FOR Loops = 0 TO 255
   OUT &H3C9, ASC(MID$(Palettez.PaletteRGB, (Loops * 3) + 1, 1)) \ 4
   OUT &H3C9, ASC(MID$(Palettez.PaletteRGB, (Loops * 3) + 2, 1)) \ 4
   OUT &H3C9, ASC(MID$(Palettez.PaletteRGB, (Loops * 3) + 3, 1)) \ 4
NEXT Loops

SEEK #255, 129
NumberOfLoops$ = SPACE$(1): PixelColor$ = SPACE$(1): x = 0: y = 0
DO
   GET #255, , NumberOfLoops$
   NumberOfLoops = ASC(NumberOfLoops$)
   IF NumberOfLoops > 191 THEN
      GET #255, , PixelColor$
      Movement = NumberOfLoops - 192
      LINE (x + XPoint, y + YPoint)-STEP(Movement, 0), ASC(PixelColor$)
      x = x + Movement
   ELSE
      PSET (x + XPoint, y + YPoint), NumberOfLoops
      x = x + 1
   END IF
   IF x = PCXHead.ImageWidth THEN
      x = 0: y = y + 1
   END IF
LOOP UNTIL y = PCXHead.ImageHeight
CLOSE

END SUB

