'''''''''''''''''''''''''''''''''''''''''''
' Program    : Displays XPM Icon Files    '
' Name       : OPENXPM Version 1.0        '
' Programmer : Yousuf Philips             '
' Company    : Y P I                      '
' Updated On : 15th of May 1998           '
' Email      : philipz85@hotmail.com      '
' Website    : http://www.philipz.com/qb/ '
'''''''''''''''''''''''''''''''''''''''''''

'/*               Do not edit this file if you distribute it.              */'
'/*  (c) Copyrighted by YPI in 1999 | All Rights Reserved | Public Domain  */'

'/* This program has been created by YPI (Basic Programming Incorporation) */'
'/* as a utility to display Linux XPM icon files.                          */'

'/* On the Linux platform, icon files are stored in XPM files. The XPM     */'
'/* files were developed to be easily embedded into 'C' programs. This     */'
'/* is able to read and display colored Linux XPM files into SCREEN 13.    */'

'/* I would like to give Special thanks to my good friend Jonathan Thorpe  */'
'/* for sending me the XPM specifications file and example files that I    */'
'/* used to create this program.                                           */'

'/* If you use any of this code in your program then you must credit YPI.  */'
'/* YPI has created an assortment of graphics loaders and players and they */'
'/* can all be found at <http://www.philipz.com/qb/>                       */'

DECLARE FUNCTION GetLine$ (FileNumber%)
DECLARE SUB OpenXPM (FileName$)
DEFINT A-Z
IF COMMAND$ <> "" THEN
FileName$ = COMMAND$
IF INSTR(FileName$, ".xpm") = 0 THEN FileName$ = FileName$ + ".xpm"
CALL OpenXPM(COMMAND$)

WHILE INKEY$ <> "": WEND: Wait$ = INPUT$(1)
Wait$ = INPUT$(1)
ELSE
   PRINT "OpenXPM v1.0"
     PRINT "(C) Data Components Software Development"
       PRINT "Code by: Yousuf Philips of Y P I, Inc."
         PRINT
           PRINT "Usage: OPENXPM[.exe] XPMFILE.XPM"
             SYSTEM
END IF

FUNCTION GetLine$ (FileNumber)

DIM Byte AS STRING * 1, EndOfLine  AS STRING * 1
EndOfLine = CHR$(10)

Restart:
ByteLine$ = ""
DO
   GET #FileNumber, , Byte
   IF Byte = EndOfLine THEN
      EXIT DO
   END IF
   ByteLine$ = ByteLine$ + Byte
LOOP UNTIL LOC(FileNumber) = LOF(FileNumber)

IF LEFT$(ByteLine$, 2) = "/*" THEN
   GOTO Restart
END IF
GetLine$ = ByteLine$

END FUNCTION

SUB OpenXPM (FileName$)

DIM ColorPalette$(255, 2)

OPEN FileName$ FOR BINARY AS #255
   IF LOF(255) = 0 THEN
      PRINT " File Is Empty"
      CLOSE #255: KILL FileName$
      EXIT SUB
   END IF
   DO
      Id$ = GetLine(255)
      IF INSTR(LCASE$(Id$), "static char") <> 0 THEN
         EXIT DO
      ELSEIF LOC(255) = LOF(255) THEN
         CLOSE #255
         EXIT SUB
      END IF
   LOOP
   ImageInfo$ = GetLine(255)
   Spacez$ = CHR$(32)

   FOR Loops = 2 TO LEN(ImageInfo$)
      OneChar$ = MID$(ImageInfo$, Loops, 1)
      IF OneChar$ <> Spacez$ AND Got = 0 THEN
         ImageW$ = ImageW$ + OneChar$: Started = 1
      ELSEIF OneChar$ <> Spacez$ AND Got = 1 THEN
         ImageH$ = ImageH$ + OneChar$: Started = 1
      ELSEIF OneChar$ <> Spacez$ AND Got = 2 THEN
         NoCol$ = NoCol$ + OneChar$: Started = 1
      ELSEIF OneChar$ <> Spacez$ AND Got = 3 THEN
         CharPixel$ = CharPixel$ + OneChar$: Started = 1
      ELSE
         IF Started = 1 THEN
            Started = 0: Got = Got + 1
         END IF
      END IF
   NEXT Loops
   ImageWidth = VAL(ImageW$): ImageHeight = VAL(ImageH$)
   NoOfColors = VAL(NoCol$): CharPerPixel = VAL(CharPixel$)

   FOR ColorPalette = 1 TO NoOfColors
      Palette$ = GetLine(255)
      PaletteNumber$ = MID$(Palette$, 2, CharPerPixel)
      ColorPalette$(ColorPalette, 0) = PaletteNumber$
      SearchPalette$ = SearchPalette$ + PaletteNumber$ + " "
      FindColor = INSTR(4, Palette$, "c")
      ColorPalette$(ColorPalette, 1) = MID$(Palette$, FindColor + 2, LEN(Palette$) - FindColor - 3)
   NEXT ColorPalette

   SCREEN 13
   FOR SetPalette = 1 TO NoOfColors
      PaletteSet$ = ColorPalette$(SetPalette, 1)
      IF PaletteSet$ <> "" THEN
         OUT &H3C8, SetPalette
         IF PaletteSet$ = "black" THEN
            Red = 0: Green = 0: Blue = 0
         ELSEIF LCASE$(PaletteSet$) = "none" THEN
            Red = 63: Green = 63: Blue = 63
         ELSEIF LEFT$(PaletteSet$, 1) = "#" THEN
            IF LEN(PaletteSet$) = 7 THEN
               Red = VAL("&H" + MID$(PaletteSet$, 2, 2)) \ 4
               Green = VAL("&H" + MID$(PaletteSet$, 4, 2)) \ 4
               Blue = VAL("&H" + MID$(PaletteSet$, 6, 2)) \ 4
            ELSEIF LEN(PaletteSet$) = 13 THEN
               Red = VAL("&H" + MID$(PaletteSet$, 2, 2)) \ 4
               Green = VAL("&H" + MID$(PaletteSet$, 6, 2)) \ 4
               Blue = VAL("&H" + MID$(PaletteSet$, 10, 2)) \ 4
            END IF
         ELSEIF LCASE$(LEFT$(PaletteSet$, 4)) = "gray" THEN
            C = VAL(MID$(PaletteSet$, 5, LEN(PaletteSet$) - 4)) \ 2
            Red = C: Green = C: Blue = C
         ELSEIF INSTR(LCASE$(PaletteSet$), "gray") <> 0 THEN
            RndColor = (RND * 16) + 16
            Red = RndColor: Green = RndColor: Blue = RndColor
         ELSEIF INSTR(LCASE$(PaletteSet$), "white") <> 0 THEN
            RndColor = (RND * 16) + 48
            Red = RndColor: Green = RndColor: Blue = RndColor
         ELSE
            Red = RND * 64: Green = RND * 64: Blue = RND * 64
         END IF
         OUT &H3C9, Red
         OUT &H3C9, Green
         OUT &H3C9, Blue
      END IF
   NEXT SetPalette
  
   NewChar = CharPerPixel + 1
   FOR Loops = 0 TO ImageHeight - 1
      Id$ = GetLine(255)
      FOR XWidth = 0 TO ImageWidth - 1
         Pixel$ = MID$(Id$, 2 + (XWidth * CharPerPixel), CharPerPixel)
         SearchPalette = (INSTR(SearchPalette$, Pixel$ + " ") \ NewChar) + 1
         PSET (XWidth, Loops), SearchPalette
      NEXT XWidth
   NEXT Loops
CLOSE #255
ERASE ColorPalette$

END SUB

